structure Parse : sig val parse: string -> AbstractSyntax.user_input list   
                      val parse_from_stream: TextIO.instream -> AbstractSyntax.user_input list    
                      val parse_from_string: string -> AbstractSyntax.user_input list   
                      end  =
struct 
  structure NDLLrVals = NDLLrValsFun(structure Token = LrParser.Token)
  structure Lex = NDLLexFun(structure Tokens = NDLLrVals.Tokens)
  structure NDLP = Join(structure ParserData = NDLLrVals.ParserData
                        structure Lex=Lex
                        structure LrParser = LrParser)

  fun parse filename =
      let val _ = (ErrorMsg.reset(); ErrorMsg.fileName := filename)
          val file = TextIO.openIn filename
          fun get _ = TextIO.input file
          fun parseerror(s,p1,p2) = ErrorMsg.error(s,p1,p2)
          val lexer = LrParser.Stream.streamify (Lex.makeLexer get)
          val (pre_exp, _) = NDLP.parse(30,lexer,parseerror,())
       in TextIO.closeIn file;
          pre_exp
      end handle LrParser.ParseError => raise ErrorMsg.Error

  fun parse_from_stream(is) = 
      let val _ = ErrorMsg.reset();
          fun get _ = TextIO.input is
          fun parseerror(s,p1,p2) = ErrorMsg.error(s,p1,p2)
          val lexer = LrParser.Stream.streamify (Lex.makeLexer get)
          val (pre_exp,_) = NDLP.parse(30,lexer,parseerror,())
      in
           pre_exp
      end handle LrParser.ParseError => raise ErrorMsg.Error

  fun parse_from_string(str) = parse_from_stream(TextIO.openString(str));


end







